<?php


namespace Schaffen\Transaction\Transaction\Managers;


use Freelabois\LaravelQuickstart\Extendables\ManipulationManager;
use Schaffen\Transaction\Transaction\Interfaces\ITransaction;
use Schaffen\Transaction\Transaction\Repositories\TransactionRepository;

class TransactionManager extends ManipulationManager
{
    public function __construct(TransactionRepository $repository)
    {
        parent::__construct($repository);
    }

   public function execute(ITransaction $transaction, $input)
   {

      $transaction->realizarSetup($input);
      $transaction->processarTransacao();
      $transaction->processarItens();
      $transaction->salvarTransacao();

      return $transaction->getTransaction();
   }

}
