<?php
/**
 * Created by PhpStorm.
 * User: Desenv-005
 * Date: 05/12/2018
 * Time: 17:51
 */

namespace Schaffen\Transaction\Transaction\Strategies\PaymentForms;

use Carbon\Carbon;
use Schaffen\Core\PaymentForm\Models\PaymentForm;
use Schaffen\Transaction\Transaction\Interfaces\IInformPaymentForm;
use Schaffen\Transaction\Transaction\Models\TransactionPaymentForm;

class WithoutPayment implements IInformPaymentForm
{
   public function geraEntrada($forma_pagamento = null, $transacao = null)
   {

      $forma_pagamento = [
         "tfp_numero_vezes" => 1,
         "tfp_valor" => '0',
         "tfp_vencimento_sempre" => 'DIA',
         "tfp_dias_entre_parcelas" => 1,
         "tfp_primeiro_vencimento" => Carbon::now(),
         "fop_codigo" => -1
      ];
      $forma_pagamento_banco = new TransactionPaymentForm($forma_pagamento);
      $forma_pagamento_banco->forma_pagamento()->associate(PaymentForm::find($forma_pagamento['fop_codigo']));

      $registro = $forma_pagamento_banco;

		if ($registro instanceof TransactionPaymentForm) {
			$registro->transacao()->associate($transacao);
			$registro->save();
		}
      return $forma_pagamento_banco;

   }

   public function getFormaPagamento()
   {
      return true;
   }

}
