<?php
/**
 * Created by PhpStorm.
 * User: Desenv-005
 * Date: 05/12/2018
 * Time: 17:06
 */

namespace Schaffen\Transaction\Transaction\Strategies\Invoices;


use Schaffen\Transaction\Transaction\Interfaces\IGenerateInvoice;
use Schaffen\Transaction\Transaction\Models\Transaction;

class WithoutInvoice implements IGenerateInvoice
{
   private $nota_fiscal;

    public function processarNotaFiscal(Transaction $transacao, array $transacao_itens, $natureza_operacao = null, $tipo_consumidor = 0, array $itens_cfops = [])
   {
      return true;
   }

    public function processarItens(array $itens = [], array $itens_cfops = [])
   {
      return true;
   }

   public function getNotaFiscal()
   {
      return $this->nota_fiscal;
   }

}